/*
 * CTU Open Contest 2010
 *
 * Sample solution: Arbitrage
 * Author: Martin Kacer
 *
 * Solution using double's (and not very optimally).
 * It has some limitations.
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

public class arbitrage {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		arbitrage instance = new arbitrage();
		while (instance.run()) {}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	static final double EPS = 1E-7;
	double dist[][];
	Map<String,Integer> curname = new HashMap<String,Integer>();

	boolean run() throws Exception {
		int cur = nextInt();
		if (cur == 0) return false;
		dist = new double[cur][cur];
		curname.clear();
		for (int i = 0; i < cur; ++i)
			curname.put(nextToken(), Integer.valueOf(i));
		int conv = nextInt();
		while (conv-- > 0) {
			int c1 = curname.get(nextToken()).intValue();
			int c2 = curname.get(nextToken()).intValue();
			String rate = nextToken();
			int d = rate.indexOf(':');
			double r = Integer.parseInt(rate.substring(0, d)) * 1.0
					/ Integer.parseInt(rate.substring(d+1));
			if (dist[c1][c2] != 0) throw new IllegalStateException(c1+":"+c2);
			dist[c1][c2] = r;
		}
		for (int k = 0 ; k < cur; ++k)
			for (int i = 0; i < cur; ++i)
				for (int j = 0; j < cur; ++j) {
					if (dist[i][k] < EPS || dist[k][j] < EPS) continue;
					if (dist[i][j] < EPS || (dist[i][k]*dist[k][j] < dist[i][j])) {
						dist[i][j] = dist[i][k] * dist[k][j];
					}
				}
		String answ = "Ok";
		for (int i = 0; i < cur; ++i) {
			if (dist[i][i] != 0 && dist[i][i] < 1-EPS)
				answ = "Arbitrage";
		}
		System.out.println(answ);
		return true;
	}
}
