/*
 * CTU Open Contest 2010
 *
 * Sample solution: Bus
 * Author: Josef Cibulka
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class bus
{
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception 
	{
		bus inst = new bus();
		inst.fill_is_holid();
		while (true)
		{
			try
			{
				inst.run();
			} catch(Exception e)
			{
				return;
			}
		}
	}
	
	boolean is_leap(int year)
	{
		if((year%4)!=0) return false;
		if((year%100)!=0) return true;
		if((year%400)!=0) return false;
		return true;
	}

	int dayofweek(int lind)
	{
		return (lind+4)%7 + 1;
	}
	
	int month_lengths[] = {31,28,31,30,31,30,31,31,30,31,30,31};

	int get_easter_monday(int y)
	{
		int golden, solar, lunar, p, ret;

		golden = (y % 19) + 1;
		solar = (y - 1600) / 100 - (y - 1600) / 400 ;
		lunar = (((y - 1400) / 100) * 8) / 25;
		p = (3003 - (11 * golden) + solar - lunar) % 30;
		if (p == 29 || (p == 28 && golden > 11)) p--;
		ret = lin_date(y,3,21)+p;
		ret += 8-(dayofweek(ret))%7; // if tmp is Sunday, we want the next Sunday
		return ret;
	}
	
	boolean is_holid[] = new boolean[1000000];
	void fill_is_holid()
	{
		for(int i=0; i<1000000;i++) is_holid[i]=false;
		for(int y=1600;y<=3000;y++)
		{
			is_holid[lin_date(y,1,1)]=true;
			is_holid[lin_date(y,5,1)]=true;
			is_holid[lin_date(y,5,8)]=true;
			is_holid[lin_date(y,7,5)]=true;
			is_holid[lin_date(y,7,6)]=true;
			is_holid[lin_date(y,9,28)]=true;
			is_holid[lin_date(y,10,28)]=true;
			is_holid[lin_date(y,11,17)]=true;
			is_holid[lin_date(y,12,24)]=true;
			is_holid[lin_date(y,12,25)]=true;
			is_holid[lin_date(y,12,26)]=true;
			is_holid[get_easter_monday(y)]=true;
		}
	}
	
	int lin_date(int y, int m, int d)
	{
		int tmp = y-1600;
		int ret = tmp*365;
		ret += (tmp+3)/4;
		ret -= (tmp+99)/100;
		ret += (tmp+399)/400;
		for(int i=1;i<m;i++) ret += month_lengths[i-1];
		ret += d;
		if(is_leap(y) && m>2) ret++;
		return ret;
	
	}
	
	int process_range(String rules, String range, int y) throws Exception
	{
		int ret=0;
		boolean flagt=false, flaga=false, flagw=false, flagd[]=new boolean[10];
		for(int i=1;i<=7;i++) flagd[i]=false;

		for(int i=0;i<rules.length();i++) 
		{
			if(rules.charAt(i)=='t') { flagt=true; flagd[7]=true; }
			if(rules.charAt(i)=='w') flagw=true;
			if(rules.charAt(i)=='a') flaga=true;
			if(rules.charAt(i)>='1' && rules.charAt(i)<='7') flagd[rules.charAt(i)-'0']=true;
		}
		String[] bdrs=range.split("-");

		if(bdrs.length<1 || bdrs.length>2) throw new Exception();
		int from=0, to=0;
		for(int i=0;i<bdrs.length;i++)
		{
			String[] dm = bdrs[i].split("\\.");
			if(dm.length!=2) throw new Exception();
			if(i==0) from = to = lin_date(y,Integer.parseInt(dm[1]),Integer.parseInt(dm[0]));
			else to = lin_date(y,Integer.parseInt(dm[1]),Integer.parseInt(dm[0]));
			if(bdrs[i].equals("29.2.") && !is_leap(y))
			{
				if(bdrs.length==1) return 0;
				if(i==1) to--;
			}
		}
		
		for(int i=from;i<=to;i++) 
		{
			int dow = dayofweek(i);
//System.out.println(range + " " + Integer.toString(i-from) + " " + Integer.toString(ret) + " " + Integer.toString(dow)); 
			if(flagd[dow]) { ret++; continue; }
			if(is_holid[i]) 
			{ 
				if(flagt) ret++; 
				continue;
			}
			if(flagd[dow]) { ret++; continue; }
			if((dow==1 || (i>=0 && dow!=6 && dow!=7 && is_holid[i-1])) && flaga) { ret++; continue; }
			if(dow<=5 && flagw) { ret++; continue; }
		}
		return ret;
	}
	
	boolean run() throws Exception 
	{
		String tm = input.readLine();
		
		String[] spl = tm.split("\\s");
		
		if (spl.length != 3) throw new Exception();

		String[] ranges=spl[1].split(",");
		
		int year = Integer.parseInt(spl[2]);
		int result = 0;
		for(int i=0;i<ranges.length;i++) result+=process_range(spl[0],ranges[i],year);
		
		System.out.println(result);
		
		return true;
	}

}
