/*
 * CTU Open Contest 2010
 *
 * Sample solution: Clock
 * Author: Josef Cibulka
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer; 

public class clock
{
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		int ret = Integer.parseInt(nextToken());
		return ret;
	} 
	char nextChar() throws Exception {
		return nextToken().charAt(0);
	} 

	public static void main(String[] args) throws Exception 
	{
		clock inst = new clock();
		for(int busnum=1; ; busnum++)
		{
			try
			{
				inst.run(busnum);
			} catch(Exception e)
			{
   			return;
			}
		}
	}
	
	int MAXN=100;

	char[][] DIGIT = {
		{'-','|','|','.','|','|','-'}, //0
		{'.','.','|','.','.','|','.'}, //1
		{'-','.','|','-','|','.','-'}, //2
		{'-','.','|','-','.','|','-'}, //3
		{'.','|','|','-','.','|','.'}, //4
		{'-','|','.','-','.','|','-'}, //5
		{'-','|','.','-','|','|','-'}, //6
		{'-','.','|','.','.','|','.'}, //7
		{'-','|','|','-','|','|','-'}, //8
		{'-','|','|','-','.','|','-'}, //9
		{'.','.','.','.','.','.','.'}  //nic
	};
	 

	int HM=1440;
	boolean dispposs[][] = new boolean[MAXN][HM];
		
	void get_display_possibilities(int ii) throws Exception
	{
		char digsegs[][] = new char[4][7];
		boolean digposs[][] = new boolean [4][11];

		for(int i=0;i<4;i++) digsegs[i][0] = nextChar();
		for(int i=0;i<8;i++) digsegs[i/2][1+(i%2)] = nextChar();
		for(int i=0;i<4;i++) digsegs[i][3] = nextChar();
		for(int i=0;i<8;i++) digsegs[i/2][4+(i%2)] = nextChar();
		for(int i=0;i<4;i++) digsegs[i][6] = nextChar();
		
		for(int i=0;i<4;i++)
		{
			for(int d=0;d<11;d++) 
			{
				digposs[i][d]=true;
				for(int seg=0;seg<7;seg++) 
				{
					if(digsegs[i][seg]!='?' && digsegs[i][seg]!=DIGIT[d][seg]) 
					{
						digposs[i][d]=false;
						break;
					}
				}
//				System.out.println(digposs[i][d]);
			}
//			System.out.println();
		}
		
		for(int i=0;i<HM;i++) dispposs[ii][i]=false;
		
		for(int h=0;h<24;h++) 
		{
			if(h<10)
			{
				if(!digposs[0][10]) continue;
			}
			else
			{
				if(!digposs[0][h/10]) continue;
			}
			if(!digposs[1][h%10]) continue;

			for(int min=0;min<60;min++)
			{
				if(!digposs[2][min/10]) continue;
				if(!digposs[3][min%10]) continue;
				dispposs[ii][h*60+min]=true;
//if(dispposs[ii][h*60+min]) System.out.println(Integer.toString(h)+":" + Integer.toString(min));
			}
		}
	}

	void print_time(int t)
	{
		System.out.print(Integer.toString(t/60)+":");
		t = t%60;
		if(t<10) System.out.println("0"+Integer.toString(t));
		else System.out.println(Integer.toString(t));
	}
	

	
	boolean run(int busnum) throws Exception 
	{
		int n = nextInt();
		int tmin[] = new int[MAXN];
		int tmax[] = new int[MAXN];
		
		if (n<=0) throw new Exception();

		get_display_possibilities(0);
		for(int ii=1;ii<n;ii++)
		{
			tmin[ii] = nextInt(); tmax[ii] = nextInt(); 
			get_display_possibilities(ii);
			for(int t=0;t<HM;t++) if(dispposs[ii][t])
			{
				boolean isok=false;
				for(int tprev=(t+HM-tmax[ii])%HM; tprev!=(t+1+HM-tmin[ii])%HM; tprev=(tprev+1)%HM) 
				{
					if(dispposs[ii-1][tprev]) isok=true;
				}
				dispposs[ii][t]=isok;
			}
		}

		for(int ii=n-2;ii>=0;ii--)
		{
			for(int t=0;t<HM;t++) if(dispposs[ii][t])
			{
				boolean isok=false;
				for(int tprev=(t+tmin[ii+1])%HM; tprev!=(t+1+tmax[ii+1])%HM; tprev=(tprev+1)%HM) 
				{
					if(dispposs[ii+1][tprev]) isok=true;
				}
				dispposs[ii][t]=isok;
			}
		}
		

		//System.out.println("Bus #"+Integer.toString(busnum));
		for(int ii=0;ii<n;ii++)
		{
			int ambig=0;
			for(int t=0;t<HM;t++)	if(dispposs[ii][t]) ambig++;
		
			if(ambig>1) System.out.println("ambiguous, " + Integer.toString(ambig) + " possibilities");
			else
			{
				for(int t=0;t<HM;t++)	if(dispposs[ii][t]) { print_time(t); break; }
			}
		}
		System.out.println();
		return true;
	}

}
