/*
 * CTU Open Contest 2010
 *
 * Sample solution: Difficult
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class difficult {
	static final int MAXN = 250000;
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		difficult instance = new difficult();
		while (instance.run()) {}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	int[] numtoA = new int[MAXN+1]; /* convert number to position in A */
	int[] seqB = new int[MAXN],
		seqC = new int[MAXN]; /* converted sequences B and C */
	int[] posinB = new int[MAXN],
		posinC = new int[MAXN]; /* position in B and C */
	int[][] prevcnt; /* how many numbers were in partitions */

	boolean run() throws Exception {
		int n = nextInt();
		if (n == 0) return false;
		for (int i = 0; i < n; ++i) {
			numtoA[nextInt()] = i;
		}
		for (int i = 0; i < n; ++i)
			posinB[seqB[i] = numtoA[nextInt()]] = i;
		for (int i = 0; i < n; ++i)
			posinC[seqC[i] = numtoA[nextInt()]] = i;
		int part = 10;
		while (part*part*part < n*n) ++part;
		prevcnt = new int[n/part+1][n/part+1]; /* must be zeroes! */
		long sum = 0;
		for (int x = 0; x < n; ++x) {
			int pb = posinB[x], pc = posinC[x];
			int pbn = pb/part, pcn = pc/part;
			int pb0 = pbn*part, pc0 = pcn*part;
			for (int i = 0; i < pbn; ++i) {
				for (int j = 0; j < pcn; ++j) {
					sum += prevcnt[i][j];
				}
			}
			for (int i = pb0; i < pb; ++i)
				if (seqB[i] < x && posinC[seqB[i]] < pc) ++sum;
			for (int j = pc0; j < pc; ++j)
				if (seqC[j] < x && posinB[seqC[j]] < pb0) ++sum; /* pb0 is intentional here! */
			prevcnt[pbn][pcn]++;
		}
		System.out.println(sum);
		return true;
	}
}
